def cut_ropes(n, k, q, queries):
    lengths = {n: 1}
    while k > 0:
        max_len = max(lengths.keys())
        count = lengths[max_len]
        if k > count:
            k -= count
            lengths[max_len // 2] = lengths.get(max_len // 2, 0) + count
            lengths[(max_len + 1) // 2] = lengths.get((max_len + 1) // 2, 0) + count
            del lengths[max_len]
        else:
            lengths[max_len // 2] = lengths.get(max_len // 2, 0) + k
            lengths[(max_len + 1) // 2] = lengths.get((max_len + 1) // 2, 0) + k
            lengths[max_len] -= k
            k = 0
            
    result = []
    for query in queries:
        total_count = 0
        for length, count in sorted(lengths.items(), reverse=True):
            total_count += count
            if query <= total_count:
                result.append(length)
                break
    
    return result

n = int(input())
k = int(input())
q = int(input())
queries = list(map(int, input().split()))

result = cut_ropes(n, k, q, queries)
print(*result)