import sys
import math

curtest = 1

was = set()

def test(n, k, q):
    global curtest
    global was
    f = open("%02d" % curtest, "w")
    print(n, file=f)
    print(k, file=f)
    print(len(q), file=f)
    print(*q, file=f)
    f.close()
    print(n, k)
    curtest += 1

import random
random.seed("iwffsh")

def allq(n):
    return [i for i in range(1, n + 1)]

def rndq(q, k1):
    was = set()
    s = []
    for i in range(q):
        while True:
            v = random.randint(1, k1)
            if v not in was:
                break
        was.add(v)
        s.append(v)
    s.sort()
    return s

test(100, 5, allq(6))

# subtask 1: n <= 5000, k = n - 1, q = n
print(curtest)
for n in [2, 5, 10, 100, 5000]:
    test(n, n - 1, allq(n))

# subtask 2: n <= 5000, q = k + 1
print(curtest)
for n in [10, 100, 1000, 5000]:
    for t in range(3):
        k = random.randint(1, n - 1)    
        test(n, k, allq(k + 1))

# subtask 3: k <= 5000
for k in [10, 239, 4999, 5000]:
    for n in [10**9, 10**16, 10**18]:
        q = random.randint(1, min(k + 1, 5000))
        test(n, k, rndq(q, k + 1))

# subtask 4: k <= 10**5
for k in [10**5, 10**5 - 239]:
    for n in [10**9, 10**16, 10**18 - 1, 10**18]:
        q = random.randint(1, min(k + 1, 5000))
        test(n, k, rndq(q, k + 1))

# subtask 5: 
for k in [10**13, 10**14 - 239, 10**17, 10**18-1]:
    for n in [10**14, 10**16, 10**18 - 1, 10**18]:
        if n < k + 1:
            continue
        q = random.randint(1, min(k + 1, 5000))
        test(n, k, rndq(q, k + 1))
