#include <bits/stdc++.h>

using namespace std;

long long ans = 0;
vector<long long> d;
map<pair<long long, long long>, long long> mp;
long long rec(long long last, long long n) {
    if (n == 1) {
        mp[{last, n}] = 1;
        return 1;
    }
    if (mp.find({last, n}) != mp.end()) {
        return mp[{last, n}];
    }
    long long cur = 0;
    for (size_t i = last; i < d.size() && d[i] * d[i] <= n; i++) {
        if (n % d[i] == 0) {
            cur += rec(i, n / d[i]);
        }
    }
    cur += rec(n, 1);
    return mp[{last, n}] = cur;
}

long long power(long long a, long long b) {
    long long res = 1;
    while (b > 0) {
        if (b & 1)
            res = res * a;
        a = a * a;
        b >>= 1;
    }
    return res;
}

int main() {
    long long n;
    cin >> n;
    int k = 1;
    long long pq = n;
    for (long long j = 30; j > 1; j--) {
        long long cur = (int)round(pow(n, 1.0 / j));
        if (power(cur, j) == n) {
            k = j;
            pq = cur;
            break;
        }
    }
    if (k == 1) {
        cout << 1 << "\n";
        return 0;
    }
    int p = 2, q = 2;
    for (int i = 2; i * i < pq; i++) {
        if (pq % i == 0) {
            p = i;
            q = pq / i;
            break;
        } 
    }
    for (int i = 0; i <= k; i++) {
        for (int j = 0; j <= k; j++) {
            if (i == 0 && j == 0 || i == k && j == k) {
                continue;
            }
            d.push_back(power(p, i) * power(p, j));
        }
    }
    sort(d.begin(), d.end());
    cout << rec(0, n) - 1 << "\n";
    return 0;
}
